from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Float, File, Boolean, Int

Goalign_Shuffle_Sites_V0_1_0 = CommandToolBuilder(tool="goalign_shuffle_sites", base_command=["goalign", "shuffle", "sites"], inputs=[ToolInput(tag="in_rate", input_type=Float(optional=True), prefix="--rate", doc=InputDocumentation(doc="Rate of shuffled sites (>=0 and <=1) (default 0.5)")), ToolInput(tag="in_rogue", input_type=Float(optional=True), prefix="--rogue", doc=InputDocumentation(doc="If set, then will take the given proportion of taxa, and will apply shuffle again on --rate of the remaining intact sites")), ToolInput(tag="in_rogue_file", input_type=File(optional=True), prefix="--rogue-file", doc=InputDocumentation(doc="Rogue sequence names output file (default 'stdout')")), ToolInput(tag="in_stable_rogues", input_type=Boolean(optional=True), prefix="--stable-rogues", doc=InputDocumentation(doc="If true, then with a given seed, rogues will always be the same with all alignments having sequences in the same order. It may not be the case if false, especially when alignemnts have different lengths.")), ToolInput(tag="in_align", input_type=File(optional=True), prefix="--align", doc=InputDocumentation(doc="Alignment input file (default 'stdin')")), ToolInput(tag="in_auto_detect", input_type=Boolean(optional=True), prefix="--auto-detect", doc=InputDocumentation(doc="Auto detects input format (overrides -p, -x and -u)")), ToolInput(tag="in_clustal", input_type=Boolean(optional=True), prefix="--clustal", doc=InputDocumentation(doc="Alignment is in clustal? default fasta")), ToolInput(tag="in_ignore_identical", input_type=Boolean(optional=True), prefix="--ignore-identical", doc=InputDocumentation(doc="Ignore duplicated sequences that have the same name and same sequences")), ToolInput(tag="in_input_strict", input_type=Boolean(optional=True), prefix="--input-strict", doc=InputDocumentation(doc="Strict phylip input format (only used with -p)")), ToolInput(tag="in_nexus", input_type=Boolean(optional=True), prefix="--nexus", doc=InputDocumentation(doc="Alignment is in nexus? default fasta")), ToolInput(tag="in_no_block", input_type=Boolean(optional=True), prefix="--no-block", doc=InputDocumentation(doc="Write Phylip sequences without space separated blocks (only used with -p)")), ToolInput(tag="in_one_line", input_type=Boolean(optional=True), prefix="--one-line", doc=InputDocumentation(doc="Write Phylip sequences on 1 line (only used with -p)")), ToolInput(tag="in_output", input_type=File(optional=True), prefix="--output", doc=InputDocumentation(doc="Shuffled alignment output file (default 'stdout')")), ToolInput(tag="in_output_strict", input_type=Boolean(optional=True), prefix="--output-strict", doc=InputDocumentation(doc="Strict phylip output format (only used with -p)")), ToolInput(tag="in_phylip", input_type=Boolean(optional=True), prefix="--phylip", doc=InputDocumentation(doc="Alignment is in phylip? default fasta")), ToolInput(tag="in_seed", input_type=Int(optional=True), prefix="--seed", doc=InputDocumentation(doc="Random Seed: -1 = nano seconds since 1970/01/01 00:00:00 (default -1)")), ToolInput(tag="in_threads", input_type=Int(optional=True), prefix="--threads", doc=InputDocumentation(doc="Number of threads (default 1)"))], outputs=[ToolOutput(tag="out_rogue_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_rogue_file", type_hint=File()), doc=OutputDocumentation(doc="Rogue sequence names output file (default 'stdout')")), ToolOutput(tag="out_output", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output", type_hint=File()), doc=OutputDocumentation(doc="Shuffled alignment output file (default 'stdout')"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Goalign_Shuffle_Sites_V0_1_0().translate("wdl", allow_empty_container=True)

